%define zlib_prefix     /usr/local/openresty/zlib
%define zlib_prefix_asan	/usr/local/openresty-asan/zlib

Summary:            The zlib compression library for OpenResty
Name:               openresty-zlib
Version:            1.3
Release:            1%{?dist}
License:            zlib and Boost
URL:                https://openresty.org/
Source0:            https://www.zlib.net/zlib-%{version}.tar.xz
Patch3000:          copy-dir.patch

BuildRequires:      libtool
#trick to avoid mock not installing zlib 
Requires:           zlib


%description
The zlib compression library for use by OpenResty ONLY


%package devel

Summary:            Development files for OpenResty's zlib library
Requires:           %{name} = %{version}-%{release}

%description devel
Provides C header and static library for OpenResty's zlib library.

%package asan
Release:            1%{?dist}
Summary:            Clang AddressSanitizer version for the zlib compression library for OpenResty
BuildRequires:      libtool, clang, compiler-rt

%description asan
The zlib compression library for use by Openresty ONLY. This is the clang AddressSanitizer build.


%package asan-devel
Summary:            Development files for OpenResty's zlib library
Release:            1%{?dist}
Requires:           openresty-zlib-asan = %{version}-%{release}


%description asan-devel
Provides C header and static library for OpenResty's clang AddressSanitizer version of zlib library.


%prep
%autosetup -p1 -n zlib-%{version}


%build
bash ./copy-dir.sh
./configure --prefix=%{zlib_prefix}
make -j`nproc` CFLAGS='-O3 -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    SFLAGS='-O3 -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    > /dev/stderr

cd asan 
export ASAN_OPTIONS=detect_leaks=0

./configure --prefix=%{zlib_prefix_asan}

make -j`nproc` CC="gcc -fsanitize=address" \
    CFLAGS='-O1 -fno-omit-frame-pointer -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    SFLAGS='-O1 -fno-omit-frame-pointer -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    LDSHARED='gcc -fsanitize=address -shared -Wl,-soname,libz.so.1,--version-script,zlib.map' \
    > /dev/stderr

cd -

%install
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/%{zlib_prefix}/share
rm -f  %{buildroot}/%{zlib_prefix}/lib/*.la
rm -rf %{buildroot}/%{zlib_prefix}/lib/pkgconfig

cd asan
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/%{zlib_prefix_asan}/share
rm -f  %{buildroot}/%{zlib_prefix_asan}/lib/*.la
rm -rf %{buildroot}/%{zlib_prefix_asan}/lib/pkgconfig
cd -

%files
%defattr(-,root,root,-)

%dir %{zlib_prefix}
%dir %{zlib_prefix}/lib
%attr(0755,root,root) %{zlib_prefix}/lib/libz.so*


%files devel
%defattr(-,root,root,-)
%{zlib_prefix}/lib/*.a
%{zlib_prefix}/include/zlib.h
%{zlib_prefix}/include/zconf.h

%files asan
%defattr(-,root,root,-)

%attr(0755,root,root) %{zlib_prefix_asan}/lib/libz.so*


%files asan-devel
%defattr(-,root,root,-)
%{zlib_prefix_asan}/lib/*.a
%{zlib_prefix_asan}/include/zlib.h
%{zlib_prefix_asan}/include/zconf.h


%changelog
* Fri Dec 8 2023 Feng Weiyao <wynnfeng@tencent.com> - 1.3-1
- initial build